Index: /branches/gui/src/lib/gui/gl_gui/glgui_box.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_box.cc	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_box.cc	(revision 8002)
@@ -73,5 +73,4 @@
 
     this->show();
-
   }
 
Index: /branches/gui/src/lib/gui/gl_gui/glgui_box.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_box.h	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_box.h	(revision 8002)
@@ -31,4 +31,6 @@
     virtual void pack(GLGuiWidget* widget);
     virtual void unpack(GLGuiWidget* widget);
+    virtual void clear();
+
     virtual void showAll();
     virtual void hideAll();
Index: /branches/gui/src/lib/gui/gl_gui/glgui_container.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_container.h	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_container.h	(revision 8002)
@@ -25,13 +25,11 @@
     virtual ~GLGuiContainer();
 
-    void init();
-
-
-    void setBorderWidth(float borderwidth);
-
-
+    /** @brief packs a widget into this one. */
     virtual void pack(GLGuiWidget* widget) = 0;
     /** unpacks a Widget from this container. @param widget the GLGuiWidget to unpack, if NULL all subwidgets will be unpackt. */
     virtual void unpack(GLGuiWidget* widget) = 0;
+    /** @brief clears all Widgets out. */
+    virtual void clear() = 0;
+
     virtual void hideAll() = 0;
     virtual void showAll() = 0;
@@ -41,5 +39,5 @@
 
   private:
-
+    void init();
   };
 }
Index: /branches/gui/src/lib/gui/gl_gui/glgui_inputline.cc
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_inputline.cc	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_inputline.cc	(revision 8002)
@@ -21,5 +21,5 @@
 {
   /**
-   * standard constructor
+   * @brief standard constructor
   */
   GLGuiInputLine::GLGuiInputLine ()
@@ -30,6 +30,6 @@
 
   /**
-   * standard deconstructor
-  */
+   * @brief standard deconstructor
+   */
   GLGuiInputLine::~GLGuiInputLine()
   {}
@@ -40,5 +40,5 @@
 
   /**
-   * initializes the GUI-element
+   * @brief initializes the GUI-element
    */
   void GLGuiInputLine::init()
@@ -53,4 +53,9 @@
   }
 
+
+  /**
+   * @brief sets the Text of the InputLine
+   * @param text The new Text.
+   */
   void GLGuiInputLine::setText(const std::string& text)
   {
@@ -61,4 +66,8 @@
   }
 
+  /**
+   * @brief appends text to the InputLine
+   * @param appendText the Text to append
+   */
   void GLGuiInputLine::append(const std::string& appendText)
   {
@@ -68,4 +77,9 @@
   }
 
+
+  /**
+   * @brief appends a Character to the InputLine
+   * @param character the Character to append.
+   */
   void GLGuiInputLine::appendCharacter(char character)
   {
@@ -76,4 +90,8 @@
 
 
+  /**
+   * @brief Removes Characters from the InputLine
+   * @param chars The count of characters to remove
+   */
   void GLGuiInputLine::removeCharacters(unsigned int chars)
   {
@@ -84,4 +102,7 @@
 
 
+  /**
+   * removes the focus from this Widget.
+   */
   void GLGuiInputLine::removedFocus()
   {
@@ -92,4 +113,9 @@
 
 
+  /**
+   * Processes an Event.
+   * @param event The event to be processed
+   * @return true if the event was catched.
+   */
   bool GLGuiInputLine::processEvent(const Event& event)
   {
@@ -130,4 +156,7 @@
 
 
+  /**
+   * @brief Resizes the Widget to the new Size-constraints.
+   */
   void GLGuiInputLine::resize()
   {
@@ -139,4 +168,8 @@
 
 
+  /**
+   * ticks the InputLine
+   * @param dt the time passed.
+   */
   void GLGuiInputLine::tick(float dt)
   {
Index: /branches/gui/src/lib/gui/gl_gui/glgui_inputline.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_inputline.h	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_inputline.h	(revision 8002)
@@ -16,7 +16,10 @@
 {
 
-  //! This is part of the openglGUI class
+  //! This is InputLine part of the openglGUI class
   /**
+   * The InputLine is a Widget, that displays a Line, that can be manipulated through
+   * Writing Text on it.
    *
+   * Whenever the Text is changed the textChanged signal is emitted.
    */
   class GLGuiInputLine : public OrxGui::GLGuiWidget
@@ -27,5 +30,4 @@
     virtual ~GLGuiInputLine();
 
-    void init();
 
     /** @returns the text of the inputLine */
@@ -36,6 +38,4 @@
     void appendCharacter(char character);
     void removeCharacters(unsigned int chars);
-    const std::string& getName() const { return this->text.getText(); };
-
 
     virtual void removedFocus();
@@ -48,7 +48,7 @@
     DeclareSignal1(textChanged, const std::string&);
 
-    private:
-      void resize();
-
+  private:
+    void init();
+    void resize();
 
   private:
@@ -60,8 +60,6 @@
     float                   delayNext;        //!< How much time must pass before next output.
 
-    static float            repeatDelay;
-    static float            repeatRate;
-
-
+    static float            repeatDelay;      //!< Repead Delay.
+    static float            repeatRate;       //!< Repeat Rate.
   };
 }
Index: /branches/gui/src/lib/gui/gl_gui/glgui_widget.h
===================================================================
--- /branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 8001)
+++ /branches/gui/src/lib/gui/gl_gui/glgui_widget.h	(revision 8002)
@@ -88,4 +88,7 @@
     void setBorderSize(float borderSize);
 
+
+    void setBackgroundColor(float x, float y, float z) { this->backMaterial().setDiffuse(x,y,z); };
+
     inline void drawRect(const Rect2D& rect) const {
       glBegin(GL_QUADS);
Index: /branches/gui/src/story_entities/simple_game_menu.cc
===================================================================
--- /branches/gui/src/story_entities/simple_game_menu.cc	(revision 8001)
+++ /branches/gui/src/story_entities/simple_game_menu.cc	(revision 8002)
@@ -104,5 +104,6 @@
   OrxGui::GLGuiSlider* slider = new OrxGui::GLGuiSlider();
   slider->connect(SIGNAL(slider, valueChanged), this, SLOT(SimpleGameMenu, TEST));
-  slider->setRange(-1, 10);
+  slider->connect(SIGNAL(slider, valueChanged), slider, SLOT(OrxGui::GLGuiWidget, setBackgroundColor));
+  slider->setRange(0, 1);
   slider->setValue(slider->min());
   slider->show();