Index: /branches/network/src/lib/graphics/importer/height_map.cc
===================================================================
--- /branches/network/src/lib/graphics/importer/height_map.cc	(revision 8013)
+++ /branches/network/src/lib/graphics/importer/height_map.cc	(revision 8014)
@@ -134,5 +134,5 @@
     w = yOffset;
 
-    PRINTF(0)("Values: i = %i, w = %i\n", i, w);
+//    PRINTF(0)("Values: i = %i, w = %i\n", i, w);
 
     // add a vertex to the list
@@ -599,7 +599,7 @@
   float c = normalVectorField [(xInt)][yInt].y;
 
-  PRINTF(0)("a: %f \n" ,a);
-  PRINTF(0)("b: %f \n" ,b);
-  PRINTF(0)("c: %f \n" ,c);
+//  PRINTF(0)("a: %f \n" ,a);
+//  PRINTF(0)("b: %f \n" ,b);
+//  PRINTF(0)("c: %f \n" ,c);
 
 
Index: /branches/network/src/lib/network/network_game_manager.cc
===================================================================
--- /branches/network/src/lib/network/network_game_manager.cc	(revision 8013)
+++ /branches/network/src/lib/network/network_game_manager.cc	(revision 8014)
@@ -57,4 +57,5 @@
 
   this->setSynchronized(true);
+
 }
 
@@ -74,4 +75,6 @@
 bool NetworkGameManager::signalNewPlayer( int userId )
 {
+  assert( SharedNetworkData::getInstance()->isGameServer() );
+  assert( State::getGameRules() );
   assert( State::getGameRules()->isA( CL_NETWORK_GAME_RULES ) );
   
@@ -84,4 +87,5 @@
   BaseObject * bo = Factory::fabricate( playableClassId );
   
+  assert( bo != NULL );
   assert( bo->isA( CL_PLAYABLE ) );
   
@@ -89,6 +93,13 @@
   
   playable.loadModel( playableModel );
+  playable.setOwner( userId );
+  playable.setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
+  playable.setSynchronized( true );
   
   PlayerStats * stats = rules.getNewPlayerStats( userId );
+  
+  stats->setUniqueID( SharedNetworkData::getInstance()->getNewUniqueID() );
+  stats->setSynchronized( true );
+  stats->setOwner( getHostID() );
   
   stats->setTeamId( team );
Index: /branches/network/src/lib/network/player_stats.cc
===================================================================
--- /branches/network/src/lib/network/player_stats.cc	(revision 8013)
+++ /branches/network/src/lib/network/player_stats.cc	(revision 8014)
@@ -59,4 +59,6 @@
   playableUniqueId_handle = registerVarId( new SynchronizeableInt( &playableUniqueId, &playableUniqueId, "playableUniqueId" ) );
   modelFileName_handle = registerVarId( new SynchronizeableString( &modelFileName, &modelFileName, "modelFileName" ) );
+  
+  PRINTF(0)("PlayerStats created\n");
 }
 
@@ -80,4 +82,6 @@
   {
     this->setPlayableUniqueId( this->playableUniqueId );
+    
+    PRINTF(0)("uniqueID changed %d %d\n", userId, getHostID());
     
     if ( userId == getHostID() )
Index: /branches/network/src/lib/network/player_stats.h
===================================================================
--- /branches/network/src/lib/network/player_stats.h	(revision 8013)
+++ /branches/network/src/lib/network/player_stats.h	(revision 8014)
@@ -24,5 +24,5 @@
     virtual void varChangeHandler( std::list<int> & id );
     
-    PlayerStats * getStats( int userId );
+    static PlayerStats * getStats( int userId );
     
     inline int getUserId(){ return userId; }
Index: /branches/network/src/lib/network/synchronizeable.cc
===================================================================
--- /branches/network/src/lib/network/synchronizeable.cc	(revision 8013)
+++ /branches/network/src/lib/network/synchronizeable.cc	(revision 8014)
@@ -36,5 +36,5 @@
 {
   this->setClassID(CL_SYNCHRONIZEABLE, "Synchronizeable");
-  this->owner = -1;
+  this->owner = 0;
   this->hostID = SharedNetworkData::getInstance()->getHostID();
   this->setIsServer(this->hostID == 0);
@@ -333,5 +333,5 @@
 void Synchronizeable::registerVar( SynchronizeableVar * var )
 {
-  PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
+  //PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
   syncVarList.push_back( var );
 }
@@ -345,5 +345,5 @@
 int Synchronizeable::registerVarId( SynchronizeableVar * var )
 {
-  PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
+  //PRINTF(0)("ADDING VAR: %s\n", var->getName().c_str());
   syncVarList.push_back( var );
   var->setWatched( true );
Index: /branches/network/src/story_entities/multi_player_world_data.cc
===================================================================
--- /branches/network/src/story_entities/multi_player_world_data.cc	(revision 8013)
+++ /branches/network/src/story_entities/multi_player_world_data.cc	(revision 8014)
@@ -45,4 +45,5 @@
 #include "network_manager.h"
 #include "network_game_manager.h"
+#include "player_stats.h"
 
 
@@ -203,4 +204,5 @@
       this->localPlayer = new Player();
 
+#if 0
       Playable* playable;
       const std::list<BaseObject*>* playableList = ClassList::getList(CL_PLAYABLE);
@@ -215,4 +217,5 @@
         playable->setPlayDirection(Quaternion(M_PI, Vector(0.0, 1.0, 0.0)));
       }
+#endif
     }
     else
@@ -244,4 +247,5 @@
   
   State::setPlayer(this->localPlayer);
+ 
 }
 
@@ -265,4 +269,10 @@
   /* call underlying function */
   GameWorldData::loadScene(root);
+  
+  if ( NetworkManager::getInstance()->isGameServer() )
+  {
+    NetworkGameManager::getInstance()->signalNewPlayer( 0 );
+    State::getPlayer()->setPlayable( PlayerStats::getStats( 0 )->getPlayable() );
+  }
 }
 