Index: branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.cc	(revision 8023)
@@ -20,9 +20,8 @@
 #include "glincl.h"
 
-/*#include "shell_command.h"
-SHELL_COMMAND(activateFog, FogEffect, FogEffect::activate)
-	->setAlias("aFog");
-SHELL_COMMAND(deactivateFog, FogEffect, FogEffect::deactivate)
-	->setAlias("dFog");*/
+#include "shell_command.h"
+
+SHELL_COMMAND(activate, FogEffect, activateFog);
+SHELL_COMMAND(deactivate, FogEffect, deactivateFog);
 
 using namespace std;
@@ -39,5 +38,6 @@
 		this->loadParams(root);
 
-	this->activate();
+  if( this->fogActivate )
+	 this->activate();
 }
 
@@ -57,4 +57,5 @@
 	LoadParam(root, "range", this, FogEffect, setFogRange);
 	LoadParam(root, "color", this, FogEffect, setFogColor);
+  LoadParam(root, "option", this, FogEffect, setFogOption);
 }
 
@@ -62,4 +63,5 @@
 {
 	//default values
+  this->fogActivate = false;
 	this->fogMode = GL_EXP2;
 	this->fogDensity = 0.001;
Index: branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/fog_effect.h	(revision 8023)
@@ -22,4 +22,7 @@
 		virtual bool activate();
 		virtual bool deactivate();
+    
+    void activateFog() { this->activate(); }
+    void deactivateFog() { this->deactivate(); }
 
 		inline void setFogMode(const std::string& mode) { this->fogMode = this->stringToFogMode(mode); }
@@ -27,4 +30,5 @@
 		inline void setFogRange(float start, float end) { this->fogStart = start; this->fogEnd = end; }
 		inline void setFogColor(float r, float g, float b) { this->colorVector = Vector(r, g, b); }
+    inline void setFogOption(const std::string& option) { if (option == "activate") this->fogActivate = true; }
 
 	private:
@@ -37,4 +41,5 @@
 		GLfloat                 fogEnd;
 		Vector                  colorVector;
+    bool                     fogActivate;
 };
 
Index: branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.cc	(revision 8023)
@@ -153,15 +153,4 @@
 }
 
-void RainEffect::activateRain()
-{
-	this->activate();
-}
-
-void RainEffect::deactivateRain()
-{
-	this->deactivate();
-}
-
-
 void RainEffect::tick (float dt)
 {
Index: branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/rain_effect.h	(revision 8023)
@@ -34,6 +34,6 @@
 		virtual bool deactivate();
 
-		void activateRain();
-		void deactivateRain();
+    void activateRain() { this->activate(); }
+    void deactivateRain() { this->deactivate(); }
 
 		virtual void tick(float dt);
Index: branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.cc	(revision 8023)
@@ -159,14 +159,4 @@
 }
 
-void SnowEffect::activateSnow()
-{
-	this->activate();
-}
-
-void SnowEffect::deactivateSnow()
-{
-	this->deactivate();
-}
-
 void SnowEffect::draw() const
 {
Index: branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h
===================================================================
--- branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h	(revision 8022)
+++ branches/atmospheric_engine/src/lib/graphics/effects/snow_effect.h	(revision 8023)
@@ -36,6 +36,6 @@
 		virtual void tick(float dt);
 
-		void activateSnow();
-		void deactivateSnow();
+    void activateSnow() { this->activate(); }
+    void deactivateSnow() { this->deactivate(); }
 
 		inline void numParticles(int n) { this->particles = n; }